#                                                          -*-makefile-gmake-*-
# Makefile.inc.  Generated from Makefile.inc.in by configure. 
# on Thu Aug 29 09:20:00 UTC 2019
#

# Define libexec dir first, since it contains tools needed to compute
# following definitions
EMC2_LIBEXEC_DIR=${exec_prefix}/libexec/linuxcnc

# Threads systems
#################

# List of thread flavors to build modules
BUILD_THREAD_FLAVORS= posix rt-preempt xenomai

# If $(threads) is not set already, try running 'flavor'; if the
# result is empty or not in $(BUILD_THREAD_FLAVORS), pick the first
# item from $(BUILD_THREAD_FLAVORS).
threads ?= $(shell echo $(BUILD_THREAD_FLAVORS) | \
	awk -v f="`${EMC2_LIBEXEC_DIR}/flavor 2>/dev/null`" '\
	{ \
	    found=$$1; \
	    split($$0,flavs); \
	    for (val in flavs) \
		if (flavs[val] == f) found=f; \
	    print found; \
	}')

# Uppercase version of flavor name for use in variables
THREADS = $(shell echo $(threads) | tr a-z- A-Z_)

HAVE_POSIX_THREADS=yes
HAVE_RT_PREEMPT_THREADS=yes
HAVE_XENOMAI_THREADS=yes
HAVE_KERNEL_THREADS=no

POSIX_THREADS_FLAVOR_ID=0
RT_PREEMPT_THREADS_FLAVOR_ID=1
XENOMAI_THREADS_FLAVOR_ID=2
THREAD_FLAVOR_ID=$($(THREADS)_THREADS_FLAVOR_ID)

POSIX_THREADS_BUILD_SYS = user-dso
RT_PREEMPT_THREADS_BUILD_SYS = user-dso
XENOMAI_THREADS_BUILD_SYS = user-dso
BUILD_SYS = $($(THREADS)_THREADS_BUILD_SYS)

# Directories
#############

prefix=/usr
exec_prefix=${prefix}

EMC2_HOME=/usr
LIB_DIR=/usr/lib

RTDIR_EXT=$(threads)

#used for install stuff
#but have them here as reference
#build system only uses EMC2_RTLIB_DIR when creating rtapi.ini
EMC2_BIN_DIR=/usr/bin
EMC2_TCL_DIR=/usr/lib/tcltk/linuxcnc
EMC2_HELP_DIR=/usr/share/doc/linuxcnc
EMC2_RTLIB_BASE_DIR=/usr/lib/linuxcnc
EMC2_RTLIB_DIR=$(EMC2_RTLIB_BASE_DIR)/$(RTDIR_EXT)
EMC2_USER_CONFIG_DIR=~/emc2/configs
EMC2_SYSTEM_CONFIG_DIR=/etc/linuxcnc
EMC2_NCFILES_DIR=/usr/share/linuxcnc/ncfiles
REALTIME=${exec_prefix}/bin/realtime
EMC2_IMAGEDIR=/usr/share/linuxcnc
GIT_VERSION=v0.1~-detached~bf09d08
GIT_CONFIG_SHA=bf09d08

# Standard configure directories
# do we really need these?
bindir = ${exec_prefix}/bin
sbindir = ${exec_prefix}/sbin
libexecdir = ${exec_prefix}/libexec
datadir = ${datarootdir}
datarootdir = ${prefix}/share
sysconfdir = /etc
sharedstatedir = ${prefix}/com
localstatedir = ${prefix}/var
libdir = ${exec_prefix}/lib
infodir = ${datarootdir}/info
mandir = /usr/share/man
includedir = ${prefix}/include
docdir = ${datarootdir}/doc/${PACKAGE_TARNAME}
sampleconfsdir = ${datadir}/linuxcnc/examples/sample-configs
ncfilesdir = ${datadir}/linuxcnc/ncfiles
tcldir = ${prefix}/lib/tcltk/linuxcnc

# i18n variables:

package = machinekit
PACKAGE_TARNAME = linuxcnc
localedir = /usr/share/locale
LANGUAGES = 

# architecture-dependent optimizations
ARCH_CFLAGS=-m64

# /Standard configure directories
RTOPT:=-O2 	$(ARCH_CFLAGS)
ULOPT:=-O2	$(ARCH_CFLAGS)
RUN_IN_PLACE = no
POSIX_THREADS_LDFLAGS = -lpthread -lrt -lcgroup 
RT_PREEMPT_THREADS_LDFLAGS = -lpthread -lrt -lcgroup 
XENOMAI_THREADS_LDFLAGS =  -lnative -lxenomai -lpthread -lrt
RT_LDFLAGS = $($(THREADS)_THREADS_LDFLAGS)

XENOMAI_THREADS_RTS=/usr/bin/xeno-config --skin=native
XENOMAI_KERNEL_THREADS_RTS=
RTAI_KERNEL_THREADS_RTS=

SHMDRV_KERNEL_DIRS = 
KERNEL_DIRS = $($(THREADS)_THREADS_KERNEL_DIRS)

XENOMAI_KERNEL_THREADS_EXTRA_SYMBOLS = 
RTAI_KERNEL_THREADS_EXTRA_SYMBOLS = 
KBUILD_EXTRA_SYMBOLS = $($(THREADS)_THREADS_EXTRA_SYMBOLS) \
	$(EMC2_RTLIB_DIR)/Module.symvers

POSIX_THREADS_RTFLAGS =  -pthread 
RT_PREEMPT_THREADS_RTFLAGS =  -pthread 
XENOMAI_THREADS_RTFLAGS =  -I/usr/include/xenomai -D_GNU_SOURCE -D_REENTRANT -D__XENO__
THREADS_RTFLAGS = $($(THREADS)_THREADS_RTFLAGS) \
	-DTHREAD_FLAVOR_ID=$(THREAD_FLAVOR_ID)

RTFLAGS := -I. $(THREADS_RTFLAGS) \
	-DRTAPI -D_GNU_SOURCE -D_FORTIFY_SOURCE=0

KERNEL_MATH_CFLAGS = $($(THREADS)_THREADS_KERNEL_MATH_CFLAGS)

ULFLAGS = -D_GNU_SOURCE -DLOCALE_DIR=\"$(localedir)\" -DPACKAGE=\"$(package)\"

POSIX_THREADS_BUILD_SYS = user-dso
RT_PREEMPT_THREADS_BUILD_SYS = user-dso
XENOMAI_THREADS_BUILD_SYS = user-dso
BUILD_SYS = $($(THREADS)_THREADS_BUILD_SYS)

MODULE_EXT = .so

CC = x86_64-linux-gnu-gcc
CC_FOR_BUILD = x86_64-linux-gnu-gcc
OBJCOPY = x86_64-linux-gnu-objcopy
LD = x86_64-linux-gnu-ld
CROSS_COMPILING = no
PKG_CONFIG = pkg-config
MANDB = /usr/bin/mandb
HIDRAW_H_USABLE = yes

POSIX_THREADS_SOURCE = rt-preempt
RT_PREEMPT_THREADS_SOURCE = rt-preempt
XENOMAI_THREADS_SOURCE = xenomai
THREADS_SOURCE = $($(THREADS)_THREADS_SOURCE)

BUILD_DRIVERS = yes
USE_PORTABLE_PARPORT_IO = no
TARGET_PLATFORM_PC = yes
TARGET_PLATFORM_SOCFPGA = 
TARGET_PLATFORM_BEAGLEBONE = 
TARGET_PLATFORM_CHIP = 
TARGET_PLATFORM_RASPBERRY = 
TARGET_PLATFORM_ZEDBOARD = 
TARGET_PLATFORM_H3 = 

HARDY_AMD64_WORKAROUND=@HARDY_AMD64_WORKAROUND@
PRECISE_MULTILIB_BUG=

ifeq ($(BUILD_SYS),user-dso)
USERMODE_PCI=yes
else
USERMODE_PCI=no
endif

# example programs
BUILD_EXAMPLES=no

# emcweb UI
BUILD_EMCWEB=yes

# webtalk
BUILD_WEBTALK=no

#  build uninished development code
BUILD_DEV=no

# enable not-yet-ported NML parts
BUILD_NMLDEP=no

# shared memory kernel driver
USE_SHMDRV=no

# example programs
BUILD_EXAMPLES=no


# zeroMQ messaging
CZMQ_CFLAGS=
CZMQ_LIBS=-lczmq -lzmq 
USE_CZMQ=yes

# protobuf messaging
PROTOC=/usr/bin/protoc
PROTOBUF_CFLAGS=-pthread 
PROTOBUF_LIBS=-lprotobuf -pthread -lpthread 
USE_PROTOBUF=yes
PROTO2JS=none

#  build protobuf Javscript bindings
BUILD_PROTO_JS=no

# jansson JSON C library
JANSSON_CFLAGS=
JANSSON_LIBS=-ljansson 
USE_JANSSON=yes

# libwebsockets C library
LWS_CFLAGS=
LWS_LIBS=-lwebsockets 
USE_LWS=yes

# SSL library
SSL_CFLAGS=
SSL_LIBS=-lssl -lcrypto 
USE_SSL=yes

# uriparser C library
URIPARSER_CFLAGS=
URIPARSER_LIBS=-luriparser 
USE_URIPARSER=yes

# avahi-client library
AVAHI_CFLAGS=-D_REENTRANT 
AVAHI_LIBS=-lavahi-common -lavahi-client 
USE_AVAHI=yes

# uuid-dev C library
UUID_CFLAGS=-I/usr/include/uuid 
UUID_LIBS=-luuid 
USE_UUID=yes

LIBBACKTRACE = -lbacktrace

#libudev for if USERMODE_PCI==yes
LIBUDEV_CFLAGS=
LIBUDEV_LIBS=-ludev 

# cgroup support
LIBCGROUP_CFLAGS=
LIBCGROUP_LIBS=-lcgroup 

# deps for xemc
CFLAGS_X = 
XLIBS = -lX11 -lXaw -lXt
HAVE_XAW = yes

# ncurses support for keystick
KEYSTICKLIBS =  -lncurses
HAVE_NCURSES = yes

# readline support for halcmd
READLINE_LIBS =  -lreadline

# flags for glib
GLIB_CFLAGS = -I/usr/include/glib-2.0 -I/usr/lib/x86_64-linux-gnu/glib-2.0/include 
GLIB_LIBS = -lglib-2.0 

# local flags for GTK include
HAVE_GTK = yes
GTK_CFLAGS = -pthread -I/usr/include/gtk-2.0 -I/usr/lib/x86_64-linux-gnu/gtk-2.0/include -I/usr/include/gio-unix-2.0/ -I/usr/include/cairo -I/usr/include/pango-1.0 -I/usr/include/atk-1.0 -I/usr/include/cairo -I/usr/include/pixman-1 -I/usr/include/libpng12 -I/usr/include/gdk-pixbuf-2.0 -I/usr/include/libpng12 -I/usr/include/pango-1.0 -I/usr/include/harfbuzz -I/usr/include/pango-1.0 -I/usr/include/glib-2.0 -I/usr/lib/x86_64-linux-gnu/glib-2.0/include -I/usr/include/freetype2 
GTK_LIBS = -lgtk-x11-2.0 -lgdk-x11-2.0 -lpangocairo-1.0 -latk-1.0 -lcairo -lgdk_pixbuf-2.0 -lgio-2.0 -lpangoft2-1.0 -lpango-1.0 -lgobject-2.0 -lglib-2.0 -lfontconfig -lfreetype 
HAVE_GNOMEPRINT = 

# tcl tk cflags, includes and libs
TCL_DBGX=
TK_DBGX=
TCL_CFLAGS=-I/usr/include/tcl8.6 -DUSE_TCL_STUBS -I/usr/include/tcl8.6 
TCL_LIBS=-ltclstub8.6 -lX11 -lXss -lXext -lXft -lfontconfig -lfreetype -lfontconfig -lpthread -ldl -lz -lpthread -lieee -lm -ltk8.6 -lGL  -lXinerama 
HAVE_WORKING_BLT=no


AR = /usr/bin/ar
ARFLAGS = cr
CXX = x86_64-linux-gnu-g++
CXXFLAGS = -g -O2 -std=c++11
RANLIB = x86_64-linux-gnu-ranlib
MSGFMT = /usr/bin/msgfmt
XGETTEXT = /usr/bin/xgettext

BUILD_DOCS = no
#BUILD_DOCS_PDF = @BUILD_DOCS_PDF@
#BUILD_DOCS_HTML = @BUILD_DOCS_HTML@
PYTHON = /usr/bin/python2
TCLSH = /usr/bin/tclsh8.6
EMC2_TCL_LIB_DIR = /usr/lib/tcltk/linuxcnc
A2X_LATEX_ENCODING = @A2X_LATEX_ENCODING@

HAVE_LIBMODBUS3   = yes
LIBMODBUS_LIBS    = -lmodbus 
LIBMODBUS_CFLAGS  = -I/usr/include/modbus 

HAVE_LIBUSB10   = yes
LIBUSB10_LIBS   = -lusb-1.0 
LIBUSB10_CFLAGS = -I/usr/include/libusb-1.0 

HAVE_LTTNG_UST   = 
LTTNG_UST_LIBS   = 
LTTNG_UST_CFLAGS = 

#
# i18n
#


#### BEGIN CONFIG ####

# To disable compilation of any particular module,
# edit the following lines replacing "m" with "n".
#
# In time, we may have some fancy dohicky to set
# these options at compile time.

# usually you need rtapi,
# so you probably don't want to change this
CONFIG_RTAPI=m

# rtapi examples
CONFIG_RTAPI_EXAMPLES_EXTINT=m
CONFIG_RTAPI_EXAMPLES_FIFO=m
CONFIG_RTAPI_EXAMPLES_SEM=m
CONFIG_RTAPI_EXAMPLES_SHMEM=m
CONFIG_RTAPI_EXAMPLES_TIMER=m

# emc motion module
CONFIG_MOTMOD=m

# HAL components
CONFIG_BLOCKS=m
CONFIG_BOSS_PLC=m
CONFIG_DEBOUNCE=m
CONFIG_ENCODER=m
CONFIG_COUNTER=m
CONFIG_ENCODER_RATIO=m
CONFIG_STEPGEN=m
CONFIG_LCD=m
CONFIG_MUX_GENERIC=m
CONFIG_MATRIX_KB=m
CONFIG_FREQGEN=m
CONFIG_PWMGEN=m
CONFIG_SIGGEN=m
CONFIG_AT_PID=m
CONFIG_PID=m
CONFIG_PEPPER=m
CONFIG_SUPPLY=m
CONFIG_CLASSICLADDER_RT=m
CONFIG_TIMEDELAY=m
CONFIG_SIM_ENCODER=m
CONFIG_WEIGHTED_SUM=m
CONFIG_WATCHDOG=m
CONFIG_MODMATH=m
CONFIG_STREAMER=m
CONFIG_SAMPLER=m
CONFIG_RINGLOAD=m

# HAL drivers
CONFIG_UPARPORT=m
CONFIG_HAL_PARPORT=m
CONFIG_PROBE_PARPORT=m
CONFIG_HAL_TIRO=m
CONFIG_HAL_EVOREG=m
CONFIG_HAL_MOTENC=m
CONFIG_HAL_SKELETON=m
CONFIG_HAL_GPIO=m
CONFIG_HM2_SOC_OL=m
CONFIG_HAL_SPI=m
CONFIG_HAL_SPEAKER=m
CONFIG_HAL_STG=m
CONFIG_HAL_VTI=m
CONFIG_HAL_AX521H=m
CONFIG_HAL_PPMC=m
CONFIG_PCI_8255=m
CONFIG_HOSTMOT2=m
CONFIG_OPTO_AC5=m
CONFIG_HAL_GM=m
CONFIG_HAL_CAN=m

# Python-related
BUILD_PYTHON=yes
PYTHON_CPPFLAGS=-I/usr/include/python2.7
PYTHON_LIBS=-lpython2.7
BOOST_PYTHON_LIB=boost_python
SITEPY=/usr/lib/python2.7/dist-packages
CYTHON=/usr/bin/cython

# Boost
BOOST_SERIALIZATION_LIB=@BOOST_SERIALIZATION_LIB@
BOOST_THREAD_LIB=-lboost_thread
# Later Boost versions need -lboost_system with -lboost_thread
BOOST_SYSTEM_LIB=-lboost_system

#### END CONFIG ####

